require "util"
require "defines"

game.on_init(function()
    Init()
end)
game.on_load(function()
    Init()
end)

function Init()
	if global.MinerList == nil then
		global.MinerList = {}
	end
	global.OreList={}
	for i = 1 , 82 do
		global.OreList[i] = "stone"
	end
	for i = 83 , 88 do
		global.OreList[i] = "coal"
	end
	for i = 89 , 93 do
		global.OreList[i] = "copper-ore"
	end
	for i = 94 , 100 do
		global.OreList[i] = "iron-ore"
	end	
--[[if dytech --need to define this
		add dytech ores
	end
	if bobsmods --need to define this
		add bobs ores
	end]]
	--game.player.print(#global.MinerList)
end

game.on_event(defines.events.on_built_entity, function(event)
    EntityBuilt(event, event.created_entity)
end)
game.on_event(defines.events.on_robot_built_entity, function(event)
    EntityBuilt(event, event.created_entity)
end)

function EntityBuilt(event, entity)
  local ent = event.created_entity
  if ent.name == "Endless-Miner" then
      table.insert(global.MinerList, ent)
	  ent.recipe = "Endless-Miner-Drilling"
  end
end

game.on_event(defines.events.on_tick, function(event)
	if event.tick % (60) == 0 then
		--game.player.print("one")
		if global.MinerList ~= nil then
			--game.player.print("two")
			for i, miner in ipairs(global.MinerList) do 
				--game.player.print("three")
				if miner.valid then --Magic starts here
					--game.player.print("four")
					if miner.fluidbox ~= nil then
						if miner.fluidbox[1] ~= nil then
							--game.player.print(#miner.fluidbox)
							
							--game.player.print(miner.fluidbox[1].amount)
							if miner.fluidbox[1].amount > 0 then
								local n = math.random(1, #global.OreList)
								local ore = global.OreList[n]
								local container = nil
								local x = 0
								local y = 0
								local line = nil
								if miner.direction==0 then
									drop_pos={miner.position.x ,miner.position.y+1.75}
									y = 2
									line = 1
								elseif miner.direction==2 then
									drop_pos={miner.position.x-1.75 ,miner.position.y}
									x = -2
									line = 1
								elseif miner.direction==4 then
									drop_pos={miner.position.x ,miner.position.y-1.75}
									y = -2
									line = 1
								elseif miner.direction==6 then
									drop_pos={miner.position.x+1.75 ,miner.position.y}
									x = 2
									line = 1
								end
								local SearchArea = {{miner.position.x + x -0.1, miner.position.y + y -0.1}, {miner.position.x + x +0.1 ,miner.position.y + y + 0.1}}
								if container == nil then
									container = game.surfaces["nauvis"].find_entities_filtered{area= SearchArea, type="container"}
								end
								if container == nil then
									container = game.surfaces["nauvis"].find_entities_filtered{area= SearchArea, type="smart-container"}
								elseif container [1] == nil then
									container = game.surfaces["nauvis"].find_entities_filtered{area= SearchArea, type="smart-container"}
								end
								if container == nil then
									container = game.surfaces["nauvis"].find_entities_filtered{area= SearchArea, type="logistic-container"}
								elseif container [1] == nil then
									container = game.surfaces["nauvis"].find_entities_filtered{area= SearchArea, type="logistic-container"}
								end
								local belt = nil
								if belt == nil then
									belt = game.surfaces["nauvis"].find_entities_filtered{area= SearchArea, type="transport-belt"}
								end
								
								if container ~= nil and container[1]~= nil and container[1].name ~= "item-on-ground" then
									container = container[1]
								else
									container = nil
								end
								if belt ~= nil and belt[1] ~= nil then
									belt = belt[1]
								else
									belt = nil
								end
								local newfluid = miner.fluidbox[1]
								newfluid.amount = newfluid.amount - 1
								if container ~=nil and container.can_insert{name=ore, count=1} then
									container.insert({name=ore, count=1})
									miner.fluidbox[1] = newfluid
								elseif belt ~= nil then
									if miner.direction == 6 and belt.direction == 4 or miner.direction == 0 and belt.direction == 6 or miner.direction == 2 and belt.direction == 0 or miner.direction == 4 and belt.direction == 2 then
										if belt.get_transport_line(2).insert_at(0.5,{name=ore, count=1}) then
											miner.fluidbox[1] = newfluid
										end
									else
										if belt.get_transport_line(1).insert_at(0.5,{name=ore, count=1}) then
											miner.fluidbox[1] = newfluid
										end
									end
								elseif game.surfaces["nauvis"].can_place_entity{name="item-on-ground" , stack = {name = ore, count = 1}, position=drop_pos} and container == nil and belt == nil then
									game.surfaces["nauvis"].create_entity{name="item-on-ground", position=drop_pos, stack = {name = ore, count = 1}}
									miner.fluidbox[1] = newfluid
								end
							end
						end
					end
				else
				global.MinerList[i] = nil
				end
			end
		end
	end
end)