data:extend(
{	
  {
    type = "assembling-machine",
    name = "Endless-Miner",
    icon = "__base__/graphics/icons/basic-mining-drill.png",
    flags = {"placeable-neutral","placeable-player", "player-creation"},
    minable = {hardness = 0.2, mining_time = 0.5, result = "Endless-Miner"},
    max_health = 300,
    corpse = "big-remnants",
    dying_explosion = "medium-explosion",
    collision_box = {{-1.4, -1.4}, {1.4, 1.4}},
    selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
    animation =
    {
      north =
      {
        filename = "__Endless-Miner__/graphics/entity/em-sa.png",
        width = 128,
        height = 128,
        frame_count = 8,
        shift = {0.2, -0.6}
      },
      west =
      {
        filename = "__Endless-Miner__/graphics/entity/em-ea.png",
        width = 128,
        height = 128,
        frame_count = 8,
        shift = {0.2, -0.3}
      },
      south =
      {
        filename = "__Endless-Miner__/graphics/entity/em-na.png",
        width = 128,
        height = 128,
        frame_count = 8,
        shift = {0.2, -0.4}
      },
      east =
      {
        filename = "__Endless-Miner__/graphics/entity/em-wa.png",
        width = 128,
        height = 128,
		frame_count = 8,
        shift = {0.2, -0.4}
      }
    },
    vehicle_impact_sound =  { filename = "__base__/sound/car-stone-impact.ogg", volume = 0.65 },
    working_sound =
    {
      sound = {
        {
          filename = "__base__/sound/electric-mining-drill.ogg",
          volume = 0.4
        }
      },
      idle_sound = { filename = "__base__/sound/idle1.ogg", volume = 0.6 },
      apparent_volume = 1.5,
    },
    crafting_speed = 1,
    energy_source =
    {
      type = "electric",
      usage_priority = "secondary-input",
      emissions = 0.1 / 5
    },
    energy_usage = "250kW",
    ingredient_count = 4,
    crafting_categories = {"Endless-Miner"},
    fluid_boxes =
    {
      {
        production_type = "output",
        --pipe_covers = pipecoverspictures(),
        base_level = 1,
        pipe_connections = {{ position = {0, 2} }}
      }
    }
  }
}
)